# Trolling

Trolling (as a verb) is a fairly recent term that has evolved alongside the [Internet](internet.md) and whose meaning ranges from an activity of purposefully causing [drama](drama.md) (mostly on the Internet) for entertainment (the original, narrower meaning) to just shamelessly abusing rules of any system for self interest on the detriment of others (wider meaning, e.g. *[patent](patent.md) trolling*, pre-election *media trolling* etc.). Core value of the narrow-sense trolling is simply [fun](fun.md) on the detriment of others -- usually making someone angry -- but not every fun making can be called trolling -- bullying weaker, for example, isn't trolling, despite it bringing some fun; trolling has to have a bit of cleverness in it, it typically finds a way of legally do something nasty, i.e. [hacking](hacking.md) the rules of the game. Trolls are those who before the Internet would be called something like jokers or pranksters, however [real life](irl.md) pranks have limited potential -- on the Internet on the other hand trolling can flourish (likely owing to the aspect of [anonymity](anonymity.md), lack of nonverbal communication, lack of consequences and responsibility and so on), so this [art](art.md) has evolved into something more, it is by now an inseparable part of Internet [culture](culture.md) (and should probably become protected by Unesco). Some forms of trolling provide so much fun they're even illegal. Trolling is not about being [evil](evil.md), it is about having fun, it is cherished by cool people who don't take things too seriously and can make fun of themselves and is therefore embraced by forums like [4chan](4chan.md); on the other hand it is demonized by those without sense of humor, those who fear the power of humor (e.g. dictators and fascists) and those who mostly get butthurt by it ([reddit](reddit.md), [Wikipedia](wikipedia.md) and other "safe space" networks). [Evil](evil.md) is always afraid of fun.

NOTE: That who performs trolling is called a *troll*, a word taken from Nordic mythology where it stands for a fantastic, weird kind of creature that lives in forests, caves or under bridges. Trolls are often a [race](race.md) in many fantasy universes (e.g. Warcraft, LOTR, Harry Potter, ...) -- there their appearance isn't very unified, some make them big, stupid giants, others paint them as tall but human sized creatures with tusks and so on. Further on we'll just be discussing trolls as related to *trolling*.

Trolling is highly associated with the troll face [meme](meme.md) -- the face has become a universal trolling symbol.

A typical example of troll occurred e.g. circa 2006 when in the game [World of Warcraft](wow.md) some guys pulled the world boss Lord Kazzak into Stormwind, one of the game's main cities, where of course this beast towering above all buildings proceeded to assrape the whole city and anything that stood in his way -- the boss couldn't even be killed because he healed every time he killed someone and with so many low level noobs and NPCs in reach he was just healing constantly. This was an ingenious move but of course, Blizzard like a huge unfunny pussy just stepped in, restarted the server and stopped all the fun because constantly dying several hours in a row was making some of their customers potentially unhappy. Blizzard is full of imbeciles who only listen to money of course.

Trolling in chat rooms and forums typically start with so called **[bait](bait.md)**, a deliberately provocative post that's meant to plant a seed of a heated discussion (see also [flame war](flame_war.md)). Such bait will intentionally say something controversial, stupid, logically faulty etc., exactly to provoke a response, it wants to attract some smartass like a fishing bait wants to attract a fish. However the art is in striking the correct balance between stupidity and seriousness, the bait mustn't be too obvious otherwise it will of course be spotted and fail (4chan calls this a "low quality bait", a famous image of highly JPEGed fishing bait is typically attached).

Here are some potentially entertaining ways of trolling (they'll be written from the point of view of a fictional character so as to avoid legal responsibility for potential crimes they may inspire lol):

- **[Link troll](suck_coq.md)**: on my website I randomly put dangerous links that look like normal links, for example "back to homepage" leads to a Google search of "free CP" or "how to get a bomb on the plane". This way anyone who clicks it automatically gets on the NSA watch list :D
- **Crime troll**:
  - **Evidence troll**: before committing crime I go to a barber shop and collect hair on the floor. Later I scatter all this hair all around the crime scene so that investigators get overwhelmed with DNA evidence of dozens of unrelated people :D This is also know as DNA [DDOS](ddos.md) (or just DOS?).
  - **Crime without motive**: criminal investigators always look for a motive in a crime, if there is none they get greatly confused, so for example as an extremely rich man owning 10 Lamborghinis I like to just steal some shitty car from time to time -- even if clues point to me they are always like "why would this rich man steal such a shitty car, it doesn't make sense". I just laugh :D 
  - **Irrational crime**: similarly investigators usually suspect some basic rationality even of the most stupid criminal -- you want to behave even stupider than that. For example I break into two stores and then just relocate goods from one to the other, then leave :D
- **Seizure troll**: when in some kind of lecture where the students are allowed laptops (typically in a compsci uni) I take a seat somewhere in the front row, near the lecturer, open my laptop and start a program that just rapidly flashes wild colors in fullscreen -- I leave it like that for the whole lecture so that everyone sitting behind me is forced to watch the flashing and can get an epileptic seizure. For educational purposes code for such a program can be written in a few lines of browser [JavaScript](javascript.md) (it may coincidentally possibly even be found in that JavaScript article).
- **[Eco](eco.md) whoring troll**: I take a bag of plastic trash, go to the forest, find some nice, clean place, take a thumbs up selfie photo with it, dump the trash in there, take another photo, then post the photos in reverse order to Twitter with something like "today I worked tirelessly to clean this garbage dump, for our children!", get a million eco likes for literally dumping plastic trash in a forest.
- **Stack overtroll**: I love to perform this troll on sites like programming advice subreddits where wannabe [soydevs](soydev.md) try to roleplay as authorities on programming -- these deserve to be trolled the most :D This gets me banned every time but it's totally worth it, I use this to leave social network sites with style once I get bored with them. I make a piece of code that looks like some noob attempt at making a game, but it's secretly an [obfuscated](obfuscation.md) code that when run does something nasty like delete all files on the computer, create one trillion subdirectories or set goatse as a wallpaper (bloat languages like [Python](python.md) are actually great for this as they can do nasty stuff like execute a dynamically constructed string and they can also download stuff from the Internet and basically do anything they like). Then I post it with a question "hello fellow programmers, I am trying to make my first game but my code doesn't work, can u help me plz?" If the code is well made, i.e. not trivial and quite hard to understand just by looking at it, chances are the first thing people are gonna do is simply copy paste the code and run it -- that's why I prefer to make the code completely destroy the computer so that the guy has to take at least a few hours to reinstall the system to be able to warn others it's a troll. Whenever some comment pops up saying it's a trap, I immediately downvote it and report it for hate speech (I also use puppet accounts here to spam the downvotes because I'll get banned anyway). The good things about this is that I actually teach people about muh [security](security.md), those who step on this mine will never run a random code from the Internet again.
- **The raycyst gayming streamtroll**: As a famous [vidya](game.md) streamer I love to do this to cause lulz, if done right I just cause drama and won't even get banned. I pick some convenient game, for example GTA or Obvlivion or something, then I just play the game, audience is watching, the catch is that I'll be making slightly racist or sexist choices in the gameplay, for example when driving between mission if I run over pedestrians, I'll only be killing black ones :D I will never buy anything from a black NPC or woman, I will never steal a black car and will prefer taking only white cars I can and so on. BUT... I won't be open about it of course! And I'll be denying it if someone starts to notice, in turn blaming him for being racist for making such observations. I can make this very subtle, for example I'll sometimes run over a white pedestrian too, but I'll keep the ratio biased towards black in such a way that it's noticeable but that it leaves them scratching their heads if it's intentional or not :'D Now if the chat starts to make drama out of it, I'll just say they're paranoid, I'll even do whatever they want me to to make them believe it's not intentional... and then I start slowly doing it again :'D Now this is funny because they can prove you nothing, and it's hilarious if you get reports and some mod literally has to go watch your streams and count the ratio of blacks versus whites you run over LMAO. Nice thing is also that if someone accuses you of racism, mod reviews it and says unconclusive, you can just ban the accuser for trolling, further scaring people from stepping in, at which point you can start being slightly more racist in the gameplay and so on, see how long you can balance on this fine line :D Another idea: play some MMORPG and be racist/sexist towards the races in the game, for example refuse to trade with female characters or speak to gnomes or whatever.
- **Troll the troll**: Advanced mastery of trolling allows one to troll other less experienced trolls -- an encounter of two trolls can be quite fun and educational. Imagine for example troll A setting up the above mentioned *stack overtroll* bait -- troll B, an experienced player of the game, notices the bait, but of course he doesn't bring this up -- no, he pretends to take the bait and responds with something like "wait a minute, let me run the code". Troll A is happy because he thinks he won, but then troll B responds: "yeah, here on line X you got this wrong, here is the correct code...". Troll A is now confused, he's unsure if he's been spotted or if troll B simply skipped running the code, troll B is now in advantage of controlling the game -- a best result here is if troll B actually somehow gets troll A to run the "fixed" code which however breaks his computer; here troll B succeeded in deflecting the troll back and catching OP into his own trap -- this kind of outcome is the best you can wish for and a showcase of true trolling mastery.
- **The richfag**: As a rich faggot I can do literally what I want so for example I bought a forest and started a company that employs people who's job it is to just run around a tree for 8 hours every day -- my goal is to have every tree have one man running around it eventually. The company is not profitable, in fact it loses money but I don't care about that, I already have infinite money. The fun thing is the people are actually grateful because I created jobs basically for all nearby villages :D
- **Creative [Wikipedia](wikipedia.md) vandalism aka [Creative TrollLolz](creative_commons.md)**: for example funny redirects or categorizations (put [Bill Gates](bill_gates.md) to "famous homosexuals" category or something), also consider vandalizing other wikis that usually don't have as much protection.
- `a:hover { display: none; }`
- **Stream/game raids** became very popular with the onset of streaming and child abusing MMOs, maybe the most iconic was the Habbo Hotel "Pool's closed" raid. [4chan](4chan.md) is one of such raid enjoyers, however very specialized groups such as soyjak.party emerged who live off almost exclusively of organizing such raids. A stream raid mostly goes like this: some toxic tranny prostitute is making children masturbate on Twitch and figures out it will steal more attention (money) by forcing audience interaction in form of some gayme in which the audience can participate -- this is where the fun begins. There are shitty games that for example let people write rap songs that are then read by text to speech synthesizer or choose titles for albums or the marble racing game where users can set their avatar pictures etc. Of course here comes the party that just storms this with images of goatse or some [nigger](nigger.md) quotes, the streamer starts to rage because he is now showing an image of protruding hairy asshole to 10000 toddlers who just wanted to watch overwatch or roblox, while in a robotic voice in the background is quoting Hitler and calling for the final solution, which of course is not very good for the streamer's career :D In best scenarios the streamer gets banned. { See for example these video clip gems at https://soyjakwiki.net/Jackbox_Raiding#Clips :D ~drummyfish }
- **Classic trollz** revolve around creating [drama](drama.md) on forums -- this is kind of an [art](art.md) as you have to keep the right balance of seriousness and stupidity; too much of the former and you're not trolling anyone, too much of the latter and you're just spotted as obvious troll. It's definitely not about logging on a starting to drop the [N-words](nigger.md) and insulting everyone, that's just an instant ban that ends the fun; you rather want to start slow, get many people seriously involved in the discussion, be polite and then slightly steer the talk towards something controversial (nice if you pretend to be part of some "oppressed minority"). Then you just make it look like you're just an uneducated simple minded individual who kind of happens to lean towards an opinion the others truly hate, but you have to keep their hope that they can convince you to change your opinion, so still try to be polite, just so you keep arguing with them and wasting more and more of their time until they start losing their shit and the thread explodes into [hitler](hitler.md) arguments etc., then just watch and enjoy.
- **Weird life goal troll**: This one requires extreme dedication and is a bit risky, but it might be one of the highest trolling peaks if performed successfully and well. So what's the troll here? We know that life goal cannot be objectively set, you can make your life goal whatever you want and no one can ever objectively refute it. So you can for example set your life goal to just walk forward -- you will dedicate everything to only walking forward as much as you can. You will stop going to work, you will only eat and drink if absolutely necessary, you'll just get up from the bed one day and start walking over the country in your pajamas -- if people ask you if you're alright you just say "yes, thank you". If you are starving, you just grab nearest food and eat it, if you need to sleep, you just lie down somewhere and sleep and then just walk again. Soon you'll probably be taken to mental asylum -- there you have to just prove you're completely normal, convince them you know what you're doing, that you're not feeling any anxiety or depression, that you hear no voices, you have only set walking as your life goal -- there is no objective way to refute this life goal. You will probably end up in asylum or jail anyway sooner or later, then just try to maximize walking, be nice and lie if you have to. If they lead you to the court, just turn around and start walking out of the building. If they put you in chains, just behave nicely and say you won't try to run away -- if they take the chains down, just start walking away. Whenever you get out of jail, just start walking again and so on. Now there is a risk that you may just waste your life without attracting any attention, but you may also become famous and then highlight the fact that current society is extremely retarded and is not ready for people who aren't conforming and just set their life goal arbitrarily.
- Prank calls to businesses can be cool, a traditional troll is for example calling two restaurants and letting them talk to each other :D This can fuck up two businesses at the same time, so it's even good for society, and the women behind the phone will be happy because it brings a little fun to their otherwise boring and repetitive slavery.
- ...

{ I got asked a very good question: is trolling in fact [fascism](fascism.md) and how can I, a LRS supporter, like it then? I want to leave at least a short answer here: Yes, seeking fun (a kind of self benefit) on the detriment of others is, at least by our definition, a form of fascism. I enjoy the acts of trolling, and though it may be partly an imperfection of me as a human being, I try to keep it compatible with LRS in the following ways. Firstly I never support actually very harmful trolling (such as "cutting for Bieber") to be DONE, though I do enjoy reviewing the cases that already happened and I may find them both funny and sad at the same time -- this is similar to how one can be a pacifist and completely reject violence while still finding some value in watching gore videos. Secondly trolling may be done to entities that aren't living beings, for example companies or states. Thirdly I may support acts of trolling that I don't think are significantly harmful, for example lighthearted pranks (the kind of joke you play on someone and it eventually entertains both of you, but it mustn't be taken too far, harm must be negligible), or Internet trolling. It's similar to sports or video games -- it is completely acceptable (and desirable) to create environments -- which must always be entered VOLUNTARILY -- that simulate amoral behavior and relieve some of our amoral animal needs, for example those for competition or fight, despite such behavior not being acceptable in other contexts. I.e. it is for example acceptable to kill each other in video games. Internet, or at least a great part of it, is such an environment -- it is a kind of playground anyone can enter voluntarily, that's known to have the kind of trolling game going on. On the Internet we only interact by speech and speech alone can never hurt anyone -- if one cannot bear reading something on the Internet, he can avoid using it (at least that's how it should be). ~drummyfish }

## See Also

- [troll personality disorder](troll_personality_disorder.md)
- [drama](drama.md)
- [fun](fun.md)
- [shitposting](shitpost.md)
- [lulz](lulz.md)
- [Encyclopedia Dramatica](dramatica.md)